﻿using Infragistics.Web.UI.GridControls;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
    public ArrayList previousProductName = new ArrayList();
    public string currentProductName = "";
    public bool isNewProductName = true;



    protected void Page_Load(object sender, EventArgs e)
    {
        if (IsPostBack)
        {
            
        }
        if (!IsPostBack)
        {
            Session["RecordCount"] = 0;
            Session["PreviousProductName"] = previousProductName;
        }
        var grid = this.WebDataGrid1;


        // Behavior
        grid.Behaviors.CreateBehavior<EditingCore>();

        grid.Behaviors.EditingCore.BatchUpdating = true;

        grid.Behaviors.EditingCore.Behaviors.CreateBehavior<CellEditing>();

        grid.Behaviors.EditingCore.Behaviors.CellEditing.EditModeActions.MouseClick = EditMouseClickAction.Single; // 单击进入编辑状态
        grid.Behaviors.EditingCore.Behaviors.CellEditing.EditModeActions.EnableOnKeyPress = true; // 单击进入编辑状态

        // ColumnResizing
        grid.Behaviors.CreateBehavior<ColumnResizing>(); // 允许调整列宽

        // Selection
        grid.Behaviors.CreateBehavior<Selection>();
        grid.Behaviors.Selection.RowSelectType = SelectType.Single;
        grid.Behaviors.Selection.CellClickAction = CellClickAction.Row;

        // CellEditing
        grid.Behaviors.EditingCore.Behaviors.CreateBehavior<CellEditing>();
        grid.Behaviors.EditingCore.Behaviors.CellEditing.EditModeActions.MouseClick = EditMouseClickAction.Single;

        grid.Behaviors.EditingCore.EditingClientEvents.RowDeleted = "RowDeleted";


        grid.AutoGenerateColumns = false;
        var table = new DataLayerProduct().GetTable();
        this.WebDataGrid1.DataSource = table;

        var fieldNames = new List<string>(){ "ProductID", "ProductName" };
        for (var i = 0; i < 20; i++)
        {
            fieldNames.Add("Remark" + (i+1).ToString());
        }
        
        var n = 0;
        foreach (var fieldName in fieldNames)
        {
            n++;
            var column = new BoundDataField();
            column.DataFieldName = fieldName;
            column.Key = fieldName;
            column.Hidden = false;
            column.Header.Text = fieldName;

            // this row cause merge cell problem of first row, if comment below source code, then no problem.
            column.Width = Unit.Pixel(100);
            
            grid.Columns.Add(column);

            var textEditorPrivider = new TextEditorProvider
            {
                ID = "Editor_" + fieldName
            };
            grid.EditorProviders.Add(textEditorPrivider);

            var editingColumnSetting = new EditingColumnSetting();
            editingColumnSetting.ColumnKey = fieldName;

            editingColumnSetting.EditorID = "Editor_" + fieldName;
            grid.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(editingColumnSetting);

        }

        // FixedColumn
        //grid.Behaviors.CreateBehavior<ColumnFixing>();
        //grid.Behaviors.ColumnFixing.ShowLeftSeparator = false;
        //grid.Behaviors.ColumnFixing.FixedColumns.Add(new FixedColumnInfo("ProductID", FixLocation.Left));


        // Style
        grid.ItemCssClass = "GridItem";
    }



}